
# This code is called by mh/lib/http_server.pl to do a simulated fork 
# on socket write on windows systems.

# Magic simulated fork using copied file handles from
#  Example: 7.22 of "Win32 Perl Scripting: Administrators Handbook" by Dave Roth
#  Published by New Riders Publishing  ISBN # 1-57870-215-1


my ($Pgm_Path, $Pgm_Name) = $0 =~ /(.*)[\\\/](.*)\.?/; 
$Pgm_Path = '.' unless $Pgm_Path; 

require "$Pgm_Path/../lib/handy_utilities.pl";
use strict;
use IO::Socket;

my $file = shift @ARGV;
my $html = &file_read($file);
unlink $file;
my $socket_handle = fileno( STDOUT );
if( my $socket = IO::Socket::INET->new_from_fd( $socket_handle, "+>" ) ) {
    $socket->send($html);
    $socket->close();
}
