# Category=Phone

# Add these entries to your mh.ini file:
#  serial_modem_port=COM1  
#  serial_modem_baudrate=38400
#  serial_modem_handshake=dtr

#
#Some good advice from chaz on debuging modems:
#
# First make sure it properly works in windows. Try to connect with it through "hyperterminal".
# Just send it a "at" command, and see if it returns "OK". If you get that far, 
# that should get rid of the error message in mh. To see if it supports callerid, 
# and figure out which kind of commands it takes, try in hyperterminal
#  "at+cid=1", "at+vcid=1", "at#cid=1", "at#vcid=1". 
# One of these will give you an "OK" if it supports it (is there any other format???). 
# Then you'll have to change the init string in mh accordingly. 
# Any modem that supports callerid will work in mh, but some (most?) of them will miss some calls.


use vars '$PhoneModemString';         # Used in voicemodem.pl

my $language_code="english";
#my $language_code="swiss-german";

# David L. reports a no-name external Rockwell modem wants #CID=1 (instead of +VCID=1)
$phone_modem = new Serial_Item ('ATE1V1X4&C1&D2S0=0+VCID=1', 'init', 'serial_modem');
#$phone_modem = new Serial_Item ('ATE1V1S40.2=1S41.6=1S42.2=1&L1M3N1', 'init', 'serial_modem');  # Zyxel 2864I-Switzerland


if ($Reload) {
    set $phone_modem 'init';               # Initialize MODEM
    print_log "Caller ID Interface has been Initialized...";
}

my $caller_id_data;
if ($PhoneModemString = said $phone_modem) {
    my $l = length $PhoneModemString;
#   print "Modem said: $PhoneModemString\n" if $l < 80;
#   print "db Modem: l=$l\n" if $l > 80;
                                # Ignore garbage data (ascii is between ! thru ~)
    $PhoneModemString = '' if $PhoneModemString !~ /^[\n\r\t !-~]+$/;
    $caller_id_data .= ' ' . $PhoneModemString;
#   $caller_id_data .= " $PhoneModemString\n";
#   if ($PhoneModemString =~ /NMBR/) {    # Use this if your modem does is number only (does not return NAME)
	if ($PhoneModemString =~ /NAME/ || $PhoneModemString =~ /FM:/) {    # Use this if you live at Switzerland
																		 # Modem said: FM:07656283xx TO:86733xx

        my ($caller, $cid_number, $cid_name, $cid_time) = &Caller_ID::make_speakable($caller_id_data, 2,$language_code);
        $Save{phone_callerid_nmbr} = $cid_number; # Save last caller for display in lcdproc.pl
        $Save{phone_callerid_time} = "$Hour:$Minute";
        $Save{phone_callerid_Time} = $Time;
        if ($caller =~ /\.wav$/) {
            play "rooms=all phone_call.wav,$caller";  # Prefix 'phone call'
        }
        else {
            if ($language_code =~/swiss-german/) {
                $caller = "Anruf von $cid_number.  Anruf ist von $caller.";
                $cid_name = $caller;
            }
            else {
                $caller = "Call from $caller.  Phone call is from $caller.";
            }
        }
#       speak("rooms=all_and_out Gender=female Voice=2 Pitch=10 Breathiness=1 Volume=100 $caller");
        speak("rooms=all_and_out mode=unmuted $caller");
        print_log "callerid data: number=$cid_number name=$cid_name time=$cid_time data=$caller_id_data";
        logit("$config_parms{data_dir}/phone/logs/callerid.$Year_Month_Now.log",  
              "$cid_number name=$cid_name data=$caller_id_data line=2");
        logit_dbm("$config_parms{data_dir}/phone/callerid.dbm", $cid_number, "$Time_Now $Date_Now $Year name=$cid_name");
#       logit_dbm("$config_parms{data_dir}/phone/callerid.dbm", '123-456-7890', "$Time_Now $Date_Now $Year name=John Doe");
        undef $caller_id_data;
    }
}

                                # Allow the port to be shared
$v_port_control1 = new Voice_Cmd("[Start,Stop] Phone Modem port monitoring");
if ($state = said $v_port_control1) {
    print_log "Phone Modem monitoring has been set to $state.";
    ($state eq 'Start') ? start $phone_modem : stop $phone_modem;
}

if ($New_Minute and is_stopped $phone_modem and is_available $phone_modem) {
    start $phone_modem;
    set $phone_modem 'init';
    print_msg "MODEM Reinitialized...";
    print_log "MODEM Reinitialized...";
}

