
# Category= Alarm_Clock
# By Douglas J. Nakakihara

=begin comment

From Doug on 2/15/2000:

I wrote a nice script that lets you set alarms (timed reminders) using a
data file. I like it cuz I can change the alarms without reloading the MH
code. Great for TV show reminders, etc. The first file below is the Perl
script and the second is an example data file, which goes in your MH
data_dir directory. Enjoy.

alarmclock.txt format:

 This is what is said for alarm one/30 8 * * 1-5
 This is what is said for alarm two/10,13,30 18 18 2 *

 --The right part is: time_cron() parameters:
   minutes, hours, day of month, month and day_of_week
 --You can remark out items with a # in column 1
 --The alarmclock.txt file goes in your MH data_dir

Example alarmclock.txt:

#### General Reminders:
Time for a lunch break!/30,40,50 11 * * 1-5
Time to stretch your legs!/10,20,30 15 * * 1-5
The trash will be picked up very soon./45,54 7 * * 3,6
Remember to change backup tapes./30,40 8,18 * * 5
##### TV Shows:
Turn on the T!V. Digital Duo is on soon!/55,59 11 * * 0
Turn on the T!V. Computer Chronicals is on soon!/25,29 12 * * 0
Turn on the T!V. Once and again is on soon!/54,58 20 * 10-12,1-5 3
Turn on the T!V. Friends is on soon!/55,59 18 * 10-12,1-5 4
##### Other:

=cut


my (@alarmdata,$alarmcount);
                  # If alarm data file changed read new data
if(file_changed("$config_parms{data_dir}/alarmclock.txt") or $Startup or $Reload) {
                  # Reset alarm data array and initialize counter
    @alarmdata=();
    $alarmcount=0;
                  # Open data file
    open(ALARMDATA,"$config_parms{data_dir}/alarmclock.txt");
                  # Read in alarms and increment counter
    print "Reading alarm clock data ($Date_Now $Time_Now):\n";
    while(<ALARMDATA>) {
                  # Process if line is not a remark
        if (substr($_,0,1) ne "#") {
                  # Remove eol chars
            chomp $_;
                  # Add line to array
            @alarmdata=(@alarmdata,$_);
                  # Increment counter
            $alarmcount++;
            print " -$_\n";
        }
    }
    print "  $alarmcount alarm(s) set.\n";
                  # Close data file
    close(ALARMDATA);
}

my ($separator,$alarm_msg,$alarm_time);
if ($New_Minute) {
    for(my $i=0; $i<$alarmcount; $i++) {
                  # Find separator
        $separator = index($alarmdata[$i],"/");
                  # Extract alarm text and time
        $alarm_msg = substr($alarmdata[$i],0,$separator);
        $alarm_time = substr($alarmdata[$i],$separator+1);
        if (time_cron("$alarm_time")) {
            speak $alarm_msg;
        }
    }
}


