
# iniedit.pl - a CGIish script for editing Misterhouse configuration parameters

no warnings;                    # Avoid redefined sub msgs

my $head = q|HTTP/1.0 200 OK
Server: MisterHouse
Content-Type: text/html
Cache-control: no-cache

<HTML>
<HEAD>
<TITLE>Misterhouse Configuration Parameters</TITLE>
</HEAD>
<LINK REL="STYLESHEET" HREF="/default.css" TYPE="text/css">
<BODY>

<DIV ID="overDiv" STYLE="position:absolute; visibility:hide; z-index:1;"></DIV>
<SCRIPT LANGUAGE="JavaScript" SRC="/overlib.js"></SCRIPT>

<script>

//Popup Window Script
//By Website Abstraction (http://wsabstract.com)
//JavaScript tutorials and over 400+ free scripts

function openpopup(parm1){
var popurl="/RUN;&iniedit_help('" + parm1 + "')"
winpops=window.open(popurl,"help","width=400,height=338,")
}

</script>

<H2>Misterhouse Configuration Parameters</H2>
<h3>Note:  If you commit, all comments and sort order of your .ini file will be filtered out of the new .ini file.
Your old .ini file will be backed up with a time/date stamp</h3>
|;

my $tail = '
</BODY>
</HTML>
';


my (%dparms, %cparms, @order, %pparms, %categories, @catorder, %changed, %help);
my $private_parms = $Pgm_Path . "/mh.private.ini";
$private_parms = $ENV{mh_parms} if $ENV{mh_parms};

my_read_opts(\%dparms, \@order, \%categories, \@catorder, "./mh.ini", 0);
my_read_opts(\%pparms, \@order, \%categories, \@catorder, $private_parms, 0);

%cparms = (%dparms, %pparms);

my %args;
foreach (@ARGV) {
    #print "$_\n";
    if (my($key, $value) = $_ =~ /([^=]+)=(.*)/) {
        $args{$key} = $value;
        next if $key eq "Category";
        next if $key eq "Commit";
        next if $key eq "Switch";
        next if $key =~ /AddKey[1234]/;
        next if $key =~ /AddValue[1234]/;
        if (! defined $cparms{$key}) {
            push @order, $key;
            $categories{$key} = "Other";
        }
        if (! defined $cparms{$key} or $cparms{$key} ne $value) {
            $changed{$key} = $value;
            $cparms{$key} = $value;
        }
    }
}

foreach (1..4) {
    if ($args{"AddKey" . $_} and $args{"AddValue" . $_}) {
        my $key = $args{"AddKey" . $_};
        my $value = $args{"AddValue" . $_};
        if (! defined $cparms{$key}) {
            push @order, $key;
            $categories{$key} = "Other";
        }
        if (! defined $cparms{$key} or $cparms{$key} ne $value) {
            $changed{$key} = $value;
            $cparms{$key} = $value;
        }
    }
}
my $category = $catorder[0];
$category = $args{Category} if $args{Category};

if (defined $args{Commit} and $args{Commit} eq "Commit Changes") {
    return commit();
}
elsif (defined $args{MakeDoc}) {
    return make_doc();
}
else {
    return edit();
}
        
sub commit {
                                # Backup old parms file
#    rename $private_parms, "$private_parms.${Year_Month_Now}_${Hour}_${Minute}_${Second}"  or 
#        print_log "Error in backup up parms file $private_parms: $!";

    open (PRIVATE, ">$private_parms") or return $head . "\nError, could not open $private_parms for writing.<p>\n" . $tail;
    print PRIVATE "# Misterhouse configuration file generated by iniedit.pl\n\n";
    my $data = '
        <A HREF="/bin/iniedit.pl">Back</A><P>The following parameters were saved:<p>
        <PRE>' . "\n";

    foreach my $key (@order) {
        if ((! defined $dparms{$key} and $cparms{$key}) or
          $cparms{$key} ne $dparms{$key}) {
            print PRIVATE $key . '=' . $cparms{$key} . "\n";
            $data .= $key . '=' . $cparms{$key} . "\n";
        }
    }
    close PRIVATE;
    $data .= '</PRE>';
#   run_after_delay 1, "run_voice_cmd 'Reload code'";
    return $head . $data . $tail;
}

sub edit {
    my $data = '
        <FORM action="/bin/iniedit.pl" method=post>
        <p><em>Category:</em> <select onClick="form.submit()" name="Category">
    ';

    foreach (@catorder, 'Other') {
        $data .= '<option' . ($_ eq $category ? ' selected' : '') . '> ' . $_. "\n";
    }

    $data .= '
        </select>
        <input type=submit name="Switch" value="Switch Category">
        <input type=submit name="Commit" value="Commit Changes">
        <input type=reset name="Reset Values" value="Reset Values">
        <TABLE WIDTH="98%" CELLSPACING=1 CELLPADDING=4 BORDER=0>
    ';

    foreach (@order) {
        next if $categories{$_} ne $category;
        $data .= '<tr><td>';
        $data .= qq[<a href="javascript:openpopup('$_')"];
#       $data .= qq[ onMouseOver="overlib('$help{$_}', RIGHT, ABOVE, HEIGHT, 1, WIDTH, 350, OFFSETX, 0)" onMouseOut="nd();"];
        $data .= '>Help</a>';
#       $data .= '<A HREF="/docs/mh.ini.html#' . $_ . '" target="docs">Help</A>';
        $data .= '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
        $data .= "<b>$_</b></td><td>";
        $data .= '<input type=text size=40 name="' . $_ . '" value="';
        $data .= map_chars($cparms{$_}) . '"><input type=button value="Set Default" onClick="' . $_ . ".value='";
        $data .= (defined $dparms{$_} ? map_chars($dparms{$_}) : '') . "'\"></td></tr>\n";
    }

    foreach (keys %changed) {
        next if $categories{$_} eq $category;
        $data .= '<input type=hidden name="' . $_ . '" value="';
        $data .= map_chars($changed{$_}) . '">' . "\n";
    }

    $data .= '
        <tr><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;User Defined
        <input type=text size=20 name="AddKey1" value="">
        </td><td><input type=text size=40 name="AddValue1" value=""></td></tr>
        <tr><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;User Defined
        <input type=text size=20 name="AddKey2" value="">
        </td><td><input type=text size=40 name="AddValue2" value=""></td></tr>
        <tr><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;User Defined
        <input type=text size=20 name="AddKey3" value="">
        </td><td><input type=text size=40 name="AddValue3" value=""></td></tr>
        <tr><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;User Defined
        <input type=text size=20 name="AddKey4" value="">
        </td><td><input type=text size=40 name="AddValue4" value=""></td></tr>
        </table>
        <p><em>Note, user defined parameters will appear in the Other category.
        To remove a user defined parameter later, clear its value.
        </form>
    ';

    return $head . $data . $tail;
}


sub iniedit_help {
    my ($parm) = @_;
    return "HTTP/1.0 200 OK
Server: MisterHouse
Content-Type: text/html
Cache-control: no-cache

<html><body>
<b>$parm</b>
<p>$help{$parm}
</body></html>"

}

                                # This function is not used
sub make_doc {
    my $data = '';
    foreach (@order) {
        next unless defined $dparms{$_};
        $data .= '<A NAME="' . $_ . '"><H3>' . $_ . '</H3></A><P>' . "\n";
        $data .= 'Insert description here.<P>' . "\n";
        $data .= '<B>Default value: </B>' . map_chars($dparms{$_}) . '<P><P>' . "\n";
    }

    return $head . $data . $tail;
}

sub map_chars {
    my ($string) = @_;
    $string =~ s/\"/&#34;/g;
    $string =~ s/\'//g;
#   $string =~ s/\'/&#39;/g;
    return $string;
}

sub my_read_opts {
    my($ref_parms, $ref_order, $ref_cats, $ref_catorder, $config_file, $debug) = @_;
    my($key, $value, $value_continued, $help, $help_flag);
                                # If debug == 0 (instead of undef) this is disabled
    print "Reading config_file $config_file\n" unless defined $debug and $debug == 0;
    open (CONFIG, "$config_file") or print "\nError, could not read config file: $config_file\n";
    my $category = "Other";
    while (<CONFIG>) {

                                # Look for help text
        if (/^\@(.+)/) {
            $help = '' unless $help_flag++;
            $help .= $1;
            next;
        }
        else {
            $help_flag = 0;
        }
        if (/ \@(.+)/) {
            $help = $1;
        }

        if ($_ =~ /^#\s*Category\s*=\s*(.*?)\s*$/) {
            $category = $1;
            push @$ref_catorder, $category if ! grep /^$category$/, @$ref_catorder;
        }

        next if /^\s*\#/;
                                # Allow for multi-line values records
        if ($key and ($value) = $_ =~ /^\s+([^\#]+)/ and $value !~ /=/) {
            $value_continued = 1;
        }
                                # Look for normal key=value records
        else {
            next unless ($key, $value) = $_ =~ /(\S+?)\s*=\s*(.*)/;
            if ($value) {
                $value =~ s/^[\#\@].*//; # Delete end of line comments
                $value =~ s/\s+[\#\@].*//;
            }
            $value_continued = 0;
            next unless $key;
        }

        $value =~ s/\s+$//;     # Delete end of value blanks

                                # Last parm wins (in case we reload parm file)
        if ($value_continued) {
            $$ref_parms{$key} .= $value;
        }
        else {
            $help{$key} = $help if $help;
            $$ref_parms{$key}  = $value;
            if (! grep /^$key$/, @$ref_order) {
                push @$ref_order, $key;
                $$ref_cats{$key} = $category;
            }
        }
        print "parm key=$key value=$$ref_parms{$key} category=$$ref_cats{$key}\n" if $debug;
    }
    close CONFIG;
    return sort keys %{$ref_parms};
}

